<template>
  <div>


    <br/>
    <h2> Edytuj ul: </h2>
    <hr>
    <form
        v-on:submit.prevent="submitForm"
    >

      <div v-if="beegardens">
        <label for="beegardenName">Jeśli chcesz przenieść ul, wybierz pasiekę do której ma on trafić. Aktualnie ul należy do
          <strong>{{ oldBeegarden.beegardenName }}.</strong></label>

        <select id="beegardenName" v-model="form.beegardenId">

          <option disabled value="">Wybierz odpowiednią:</option>
          <option v-for="item in beegardens"
                  v-bind:key="item.id"
                  :value=item.id
          >{{ item.beegardenName }}
          </option>

        </select>
      </div>

      <hr>

      <div class="form-group">
        <label for="beehiveName">Nowa nazwa:</label>
        <input type="text"
               class="form-control"
               id="beehiveName"
               maxlength="30"
               placeholder="Nazwa Twojego ula"
               @input="e => form.beehiveName = e.target.value"
        />
      </div>

      <hr>

      <div class="form-group">
        <label>Nowy rodzaj ula:</label>

        <div class="form-check form-check-inline">
          <input class="form-check-input"
                 type="radio"
                 name="type"
                 id="type_wielkopolski"
                 value="wielkopolski"
                 @input="e => form.type = e.target.value"
                 :checked="oldBeehive.type === 'wielkopolski'"
          />
          <label class="form-check-label" for="type_wielkopolski">wielkopolski</label>

        </div>
        <div class="form-check form-check-inline">
          <input class="form-check-input"
                 type="radio"
                 name="type"
                 id="type_dadanta"
                 value="dadanta"
                 @input="e => form.type = e.target.value"
                 :checked="oldBeehive.type === 'dadanta'"
          >
          <label class="form-check-label" for="type_dadanta">dadanta</label>
        </div>
        <div class="form-check form-check-inline">
          <input class="form-check-input"
                 type="radio"
                 name="type"
                 id="type_warszawski_p"
                 value="warszawski poszerzony"
                 @input="e => form.type = e.target.value"
                 :checked="oldBeehive.type === 'warszawski poszerzony'"
          >
          <label class="form-check-label" for="type_warszawski_p">warszawski poszerzony</label>
        </div>
        <div class="form-check form-check-inline">
          <input class="form-check-input"
                 type="radio"
                 name="type"
                 id="type_warszawski_z"
                 value="warszawski zwykły"
                 @input="e => form.type = e.target.value"
                 :checked="oldBeehive.type === 'warszawski zwykły'"
          >
          <label class="form-check-label" for="type_warszawski_z">warszawski zwykły</label>
        </div>
        <div class="form-check form-check-inline">
          <input class="form-check-input"
                 type="radio"
                 name="type"
                 id="type_langstroth"
                 value="langstroth"
                 @input="e => form.type = e.target.value"
                 :checked="oldBeehive.type === 'langstroth'"
          >
          <label class="form-check-label" for="type_langstroth">langstroth</label>
        </div>
        <div class="form-check form-check-inline">
          <input class="form-check-input"
                 type="radio"
                 name="type"
                 id="type_ostrowskiej"
                 value="ostrowskiej"
                 @input="e => form.type = e.target.value"
                 :checked="oldBeehive.type === 'ostrowskiej'"
          >
          <label class="form-check-label" for="type_ostrowskiej">ostrowskiej</label>
        </div>
        <div class="form-check form-check-inline">
          <input class="form-check-input"
                 type="radio"
                 name="type"
                 id="type_apipol"
                 value="apipol"
                 @input="e => form.type = e.target.value"
                 :checked="oldBeehive.type === 'apipol'"
          >
          <label class="form-check-label" for="type_apipol">apipol</label>
        </div>
      </div>

      <hr>

      <div class="form-group">

        <label for="dateOfCreation">Nowa data założenia ula:</label>
        <vue-englishdatepicker
            id="dateOfCreation"
            v-model="form.dateOfCreation"
        />
        Aktualnie ul ma datę założenia: <strong>{{ oldBeehive.dateOfCreation }}</strong>
      </div>

      <hr>

      <div class="form-group">

        <label for="framesAmount">Nowa ilość ramek:</label>
        <br/>
        <VueSimpleRangeSlider
            id="framesAmount"
            style="width: 500px"
            :min="10"
            :max="100"
            :logarithmic="false"
            v-model="form.framesAmount"
        />
      </div>

      Aktualnie ul posiada <strong>{{ oldBeehive.framesAmount }}</strong> ramek.

      <hr>

      <div class="form-group">

        <label for="trunksAmount">Nowa ilość korpusów:</label>

        <br/>

        <VueSimpleRangeSlider
            id="trunksAmount"
            style="width: 500px"
            :min="1"
            :max="10"
            :logarithmic="false"
            v-model="form.trunksAmount"
        />

        <div v-if="oldBeehive.trunksAmount === 1">Aktualnie ul posiada <strong>{{ oldBeehive.trunksAmount }}</strong>
          korpus.
        </div>
        <div v-if="oldBeehive.trunksAmount !== 1">Aktualnie ul posiada <strong>{{ oldBeehive.trunksAmount }}</strong>
          korpusów.
        </div>
      </div>

      <hr>

      <div class="form-group">
        <label for="bottom">Nowy rodzaj dennicy:</label>

        <select id="bottom" v-model="form.bottom">
          <option disabled value="">Wybierz odpowiednią:</option>
          <option>higieniczna</option>
          <option>z poławiaczem pyłku</option>
          <option>niska ocieplana</option>
        </select>

        <br/><br/>
        Aktualnie ul posiada dennicę <strong>{{ oldBeehive.bottom }}</strong>.

      </div>

      <hr>

      <div class="form-group">
        <label for="feeder">Podkarmiaczka?</label>
        <input type="checkbox"
               id="feeder"
               :checked="oldBeehive.feeder === true"
               v-on:input="form.feeder = $event.target.checked; flagFeeder = true"
        >
      </div>

      <div class="form-group">
        <label for="poolenTrapper">Poławiacz pyłku?</label>
        <input type="checkbox"
               id="poolenTrapper"
               :checked="oldBeehive.poolenTrapper === true"
               v-on:input="form.poolenTrapper = $event.target.checked; flagPoolenTraper = true"
        >
      </div>

      <div class="form-group">
        <label for="propolisSinker">Poławiacz propolisu?</label>
        <input type="checkbox"
               id="propolisSinker"
               :checked="oldBeehive.propolisSinker === true"
               v-on:input="form.propolisSinker = $event.target.checked; flagPropolisSinker = true"
        >
      </div>

      <div class="form-group">
        <label for="queenCage">Izolator matek?</label>
        <input type="checkbox"
               id="queenCage"
               :checked="oldBeehive.queenCage === true"
               v-on:input="form.queenCage = $event.target.checked; flagQueenCage = true"
        >
      </div>

      <div class="form-group">
        <label for="barrier">Krata odgrodowa?</label>
        <input type="checkbox"
               id="barrier"
               :checked="oldBeehive.barrier === true"
               v-on:input="form.barrier = $event.target.checked; flagBarrier = true"
        >
      </div>

      <div class="form-group">
        <label for="isolator">Izolator?</label>
        <input type="checkbox"
               id="isolator"
               :checked="oldBeehive.isolator === true"
               v-on:input="form.isolator = $event.target.checked; flagIsolator = true"
        >
      </div>

      <div class="form-group">
        <label for="heater">Podgrzewany?</label>
        <input type="checkbox"
               id="heater"
               :checked="oldBeehive.heater === true"
               v-on:input="form.heater = $event.target.checked; flagHeater = true"
        >
      </div>

      <div class="form-group">
        <label for="queenCell">Czerw?</label>
        <input type="checkbox"
               id="queenCell"
               :checked="oldBeehive.queenCell === true"
               v-on:input="form.queenCell = $event.target.checked; flagQueenCell = true"
        >
      </div>

      <div class="form-group">
        <label for="swarmMood">Nastrój rojowy?</label>
        <input type="checkbox"
               id="swarmMood"
               :checked="oldBeehive.swarmMood === true"
               v-on:input="form.swarmMood = $event.target.checked; flagSwarmMood = true"
        >
      </div>

      <div class="form-group">
        <label for="lackOfFood">Brak pokarmu?</label>
        <input type="checkbox"
               unchecked-value="false"
               id="lackOfFood"
               :checked="oldBeehive.lackOfFood === true"
               v-on:input="form.lackOfFood = $event.target.checked; flagLackOfFood = true"
        >
      </div>

      <hr>

      <div class="form-group">

        <label for="inletWidth">Szerokość wylotka:</label>
        <br/>
        <VueSimpleRangeSlider
            id="inletWidth"
            style="width: 500px"
            :min="1"
            :max="40"
            :logarithmic="false"
            v-model="form.inletWidth"
        />
        Aktualnie ul ma wylotek o szerokości <strong>{{ oldBeehive.inletWidth }}</strong>cm.
      </div>

      <hr>

      <div class="form-group">

        <label for="workFramesAmount">Ilość ramek pracy:</label>
        <br/>
        <VueSimpleRangeSlider
            id="workFramesAmount"
            style="width: 500px"
            :min="1"
            :max="40"
            :logarithmic="false"
            v-model="form.workFramesAmount"
        />
        <div v-if="oldBeehive.workFramesAmount === 1">Aktualnie ul posiada <strong>1</strong> ramkę pracy.</div>
        <div v-if="oldBeehive.workFramesAmount !== 1">Aktualnie ul posiada
          <strong>{{ oldBeehive.workFramesAmount }}</strong> ramek pracy.
        </div>
      </div>

      <hr>

      <div class="form-group">
        <label for="force">Siła rodziny:</label>
        <select id="force" v-model="form.force">
          <option disabled value="">Siła:</option>
          <option>Słaba</option>
          <option>Średnia</option>
          <option>Mocna</option>
        </select>

      </div>
      Aktualnie rodzina oznaczona jako <strong>{{ oldBeehive.force }}</strong>
      <hr>

      <div class="form-group">
        <label for="temperament">Temperament rodziny:</label>
        <select id="temperament" v-model="form.temperament">
          <option disabled value="">Temperament:</option>
          <option>Potulna</option>
          <option>Średnia</option>
          <option>Agresywna</option>
        </select>
      </div>

      Aktualny temperament rodziny to <strong>{{ oldBeehive.temperament }}</strong>

      <hr>

      <div class="form-group">

        <div v-if="wasSubmitted && !form.grubs">
          <p style="color: red;">Uzupełnij: </p>
        </div>

        <label for="grubs">Ilość czerwiu:</label>
        <br/>
        <VueSimpleRangeSlider
            id="grubs"
            style="width: 500px"
            :min="1"
            :max="10"
            :logarithmic="false"
            v-model="form.grubs"
        />
        Aktualnie w ulu masz <strong>{{ oldBeehive.grubs }}</strong>% czerwiu.
      </div>

      <hr>

      <div class="form-group">

        <div v-if="wasSubmitted && !form.propolis">
          <p style="color: red;">Uzupełnij: </p>
        </div>

        <label for="propolis">Ilość pyłku:</label>
        <br/>
        <VueSimpleRangeSlider
            id="propolis"
            style="width: 500px"
            :min="1"
            :max="40"
            :logarithmic="false"
            v-model="form.propolis"
        />
        Aktualna ilość pyłku w ulu to <strong>{{ oldBeehive.propolis }}</strong>%.
      </div>

      <hr>

      <div class="form-group">

        <div v-if="wasSubmitted && !form.honey">
          <p style="color: red;">Uzupełnij: </p>
        </div>

        <label for="honey">Ilość miodu:</label>
        <br/>
        <VueSimpleRangeSlider
            id="honey"
            style="width: 500px"
            :min="1"
            :max="40"
            :logarithmic="false"
            v-model="form.honey"
        />
        Aktualna ilość miodu w ulu to <strong>{{ oldBeehive.honey }}</strong>%.
      </div>

      <div class="form-group">
        <button class="btn btn-primary">Edytuj</button>
      </div>
    </form>
  </div>
</template>

<script>
import VueEnglishdatepicker from 'vue-englishdatepicker';
import beehiveobject from "@/models/beehiveobject";
import VueSimpleRangeSlider from 'vue-simple-range-slider';
import 'vue-simple-range-slider/dist/vueSimpleRangeSlider.css'
import BeegardenService from '../../services/beegarden.service'
import BeehiveService from '../../services/beehive.service'

export default {
  name: 'EditBeehive',
  components: {
    VueEnglishdatepicker,
    VueSimpleRangeSlider
  },
  data() {
    return {
      form: new beehiveobject(false, '', '', '', '',
          '', false, '', '', false, '', '', false,
          false, false, '', false, false, false,
          false, '', '', '', ''),

      response: '',
      wasSubmitted: false,
      beegardens: '',
      oldBeehive: '',
      oldBeegarden: '',

      flagFeeder: false, flagPoolenTraper: false, flagPropolisSinker: false, flagQueenCage: false, flagBarrier: false,
      flagIsolator: false, flagHeater: false, flagQueenCell: false, flagSwarmMood: false, flagLackOfFood: false
    }
  },
  computed: {
    currentUser() {
      return this.$store.state.auth.user;
    }
  },
  mounted() {

    if (!this.currentUser)
      this.$router.push('/login');
    else {

      BeegardenService.getAllBeegardensFromUser(this.currentUser.id).then(
          response => {
            this.beegardens = response.data;
          },
          error => {
            this.beegardens =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );

      BeehiveService.getBeehiveById(this.$route.query.beehiveId).then(
          response => {
            this.oldBeehive = response.data;
            document.getElementById("beehiveName").value = this.oldBeehive.beehiveName;
          },
          error => {
            this.oldBeehive =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );

      BeegardenService.getSpecificBeegardenById(this.$route.query.beegardenId).then(
          response => {
            this.oldBeegarden = response.data;
          },
          error => {
            this.oldBeegarden =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );


    }
  },

  methods: {

    submitForm() {
      if (!this.currentUser) {
        this.$router.push('/login');
      } else if (this.$route.query.beehiveId) {

        this.wasSubmitted = true

        this.putOldData();

        BeehiveService.editSpecificBeehive(this.form, this.$route.query.beehiveId).then(
            response => {
              this.response = response.data;
              alert('Ul edytowany poprawnie! :)')
              this.$router.push('/beehive?beehiveid=' + this.$route.query.beehiveId);
            },
            error => {
              this.response =
                  (error.response && error.response.data && error.response.data.message) ||
                  error.message ||
                  error.toString();
            }
        )

      }
    },

    putOldData() {

      if (!this.form.beegardenId)
        this.form.beegardenId = this.oldBeehive.beegardenId;

      if (!this.form.beehiveName)
        this.form.beehiveName = this.oldBeehive.beehiveName;

      if (!this.form.bottom)
        this.form.bottom = this.oldBeehive.bottom;

      if (!this.form.dateOfCreation)
        this.form.dateOfCreation = this.oldBeehive.dateOfCreation;

      if (!this.form.force)
        this.form.force = this.oldBeehive.force;

      if (!this.form.framesAmount)
        this.form.framesAmount = this.oldBeehive.framesAmount;

      if (!this.form.grubs)
        this.form.grubs = this.oldBeehive.grubs;

      if (!this.form.honey)
        this.form.honey = this.oldBeehive.honey;

      if (!this.form.inletWidth)
        this.form.inletWidth = this.oldBeehive.inletWidth;

      if (!this.form.propolis)
        this.form.propolis = this.oldBeehive.propolis;

      if (!this.form.temperament)
        this.form.temperament = this.oldBeehive.temperament;

      if (!this.form.trunksAmount)
        this.form.trunksAmount = this.oldBeehive.trunksAmount;

      if (!this.form.type)
        this.form.type = this.oldBeehive.type;

      if (!this.form.workFramesAmount)
        this.form.workFramesAmount = this.oldBeehive.workFramesAmount;

      if (!this.flagFeeder)
        this.form.feeder = this.oldBeehive.feeder;

      if (!this.flagPoolenTraper)
        this.form.poolenTrapper = this.oldBeehive.poolenTrapper;

      if (!this.flagPropolisSinker)
        this.form.propolisSinker = this.oldBeehive.propolisSinker;

      if (!this.flagQueenCage)
        this.form.queenCage = this.oldBeehive.queenCage;

      if (!this.flagBarrier)
        this.form.barrier = this.oldBeehive.barrier;

      if (!this.flagIsolator)
        this.form.isolator = this.oldBeehive.isolator;

      if (!this.flagHeater)
        this.form.heater = this.oldBeehive.heater;

      if (!this.flagQueenCell)
        this.form.queenCell = this.oldBeehive.queenCell;

      if (!this.flagSwarmMood)
        this.form.swarmMood = this.oldBeehive.swarmMood;

      if (!this.flagLackOfFood)
        this.form.lackOfFood = this.oldBeehive.lackOfFood;

    }
  }
};

</script>

<style scoped>
label {
  display: block;
  margin-top: 10px;
}
</style>